#!/bin/bash

#### This script doens't make any sense to me....

#****** internal_audio_init.sh
# NAME
# 	multiuser_audio_init.sh
#
# AUTHOR
# 	Rocky
#
# DESCRIPTION
# 	Inital shell script for multiuser audio in common-session-startup.sh to check onboard audio and modify /etc/usbaudio config.
# 	The process includes:
# 	1) Check onboard audio & write to /etc/usbaudio config file.
# 	2) Deal with onboard audio enbaled/disbaled and assign to specific station.
# 	3) Leave USB audio stuff managed by hotplug stuff.
# 	4) For onboard audio policy: if there is no USB audio device, assign the onboard audio to station_0;
#                                if there is USB audio device, disabled onboard audio;
# 	5) Need device_sharing scipt to remove /opt/userful/locks/audio_boot_up at every bootup.
# 	6) Execute only once after every bootup.
#
# TODO:
# 	This is not used in DM. Need to test with DST.
#
logfile="/var/log/userful-multiuser-device.log"

if [ ! -e /etc/usbaudio ]; then
	touch /etc/usbaudio
fi

### ???????????????????????
# Jason: Oh, man!  This is very strange.... need to investigate more...
###
if [ "`grep -c Internal_Audio /etc/usbaudio`" = "0" ]; then  # There is no Internal_Audio string in the /etc/usbaudio file

	echo "no Internal_Audio" >> $logfile
    cp -f /etc/usbaudio /etc/usbaudio.old

	# Check internal audio assignment to see if it conflicts with USB audio, if then, disable it; Otherwise enable it.
	internal_audio_assigned_station_name=`grep Internal_Audio /etc/usbaudio.old| awk '{print $3}'` 
	# ????????????????
	# This value should have always NULL because there is no Internal_Audio string in the usbaudio.old file.
	#

    sed '/Internal_Audio/d' /etc/usbaudio.old >/etc/usbaudio

    conflict=0
    if [ "$internal_audio_assigned_station_name" != "" ]; then
       conflict=`grep -c $internal_audio_assigned_station_name /etc/usbaudio`
    fi

    if [ -d /opt/userful/locks ]; then
       echo 1 >/opt/userful/locks/audio_bootup
    fi

    search_result=0
    onboard_audio_alsa_device_name=""
    count=0
	if [ ! -d /sys/class/sound ]; then
		exit 1
	fi
    for pcm_device_dir in `ls /sys/class/sound |grep 'pcmC.D0c'`
    do
       if [ -e /sys/class/sound/$pcm_device_dir/driver ]; then
		  # ???????????????????
		  # The path should be changed to /sys/class/sound/$pcm_device_dir/device/driver
		  # No driver file in this directory
          search_result=`ls -l /sys/class/sound/$pcm_device_dir/driver |grep -c pci`
       else
          search_result=0
       fi
	   ## ???
	   ## No concern about multiple internal audios
       if [ $search_result -eq 1 ]; then
          onboard_audio_alsa_device_name=`echo ${pcm_device_dir:4:1}`
          onboard_audio_physical_location=`ls -l /sys/class/sound/$pcm_device_dir |grep device |awk '{print substr($11,9)}'`
          count=`expr $count + 1`
       fi
    done

   # Add one line about onboard audio to /etc/usbaudio file.
    if [ $count -eq 0 ]; then
        echo "No internal audio found." >> $logfile
    elif [ $count -eq 1 ]; then
          if [ "$internal_audio_assigned_station_name" != "" ] && [ $conflict -eq 0 ]; then
               echo "Internal_Audio hw:$onboard_audio_alsa_device_name $internal_audio_assigned_station_name R/W $onboard_audio_physical_location" >> \ 
			   /etc/usbaudio
          elif [ "`cat /etc/fedora-release | awk '{print $1,$2}'`" = "Userful release" ]; then
               echo "Internal_Audio hw:$onboard_audio_alsa_device_name Disabled R/W $onboard_audio_physical_location" >>/etc/usbaudio

          else
               echo "Internal_Audio hw:$onboard_audio_alsa_device_name Srn:0.0 R/W $onboard_audio_physical_location" >>/etc/usbaudio
          fi
       # Set volume of internal audio
       amixer set -c $onboard_audio_alsa_device_name Master 100 unmute
       amixer set -c $onboard_audio_alsa_device_name PCM 100 unmute
       amixer set -c $onboard_audio_alsa_device_name CD 100 unmute
    elif [ $count -gt 1 ]; then
       if [ "$onboard_audio_alsa_device_name" != "" ]; then
            # Deal with internal audio assignment (already assigned)
            if [ "$internal_audio_assigned_station_name" != "" ] && [ $conflict -eq 0 ];then
               echo "Internal_Audio hw:$onboard_audio_alsa_device_name $internal_audio_assigned_station_name R/W $onboard_audio_physical_location" >> \
			   /etc/usbaudio
            else
               echo "Internal_Audio hw:$onboard_audio_alsa_device_name Disabled R/W $onboard_audio_physical_location" >>/etc/usbaudio
            fi
            amixer set -c $onboard_audio_alsa_device_name Master 100 unmute
            amixer set -c $onboard_audio_alsa_device_name PCM 100 unmute
            amixer set -c $onboard_audio_alsa_device_name CD 100 unmute  
       else
            echo "No internal audio found."
       fi
       
    fi

fi

#***
    

