#!/bin/bash
#
# umx-session-init.sh
#
# Author:
#   Jason Kim <jason@userful.com>
#
# Description:
#   - This is run as normal login user
#   - Configure session properly to support multistation devices.
# Copyright (c) 2002-2007 by Userful Corporation
#
# Called from: umx-session-init.desktop (when Gnome session starts)
#              - /etc/xdg/autostart for Debian 4.0
#
logfile="/var/log/userful-start.log"
ProgramName=`basename $0`

if [ -x /opt/userful/bin/multistation-audio-session-startup.sh ]; then
	/opt/userful/bin/multistation-audio-session-startup.sh
fi

if [ -x /opt/userful/bin/multistation-storage-session-startup.sh ]; then
	/opt/userful/bin/multistation-storage-session-startup.sh
fi
